/** \file
 */

/*
 *  
 * Title:   Buffer Handling
 * Author(s): Domnic Savio
 *
 * ------------------------------------------------------------------
 * @version: $Id: buffer.h,v 1.5.2.3 2012/07/14 18:12:40 benya Exp $
 * ------------------------------------------------------------------ 
 *
 */

#ifndef BUFFER_H
#define BUFFER_H 

#include "util.h"

/// maximum length of buffer
#define MAX_BUF_LEN  170


/** A buffer. */
struct BUFFER {
  /// Number of chars in buffer (up to MAX_BUF_LEN).
	 int len;
  /// Contains the data.
	char data[MAX_BUF_LEN];
};
typedef struct BUFFER Buffer;
//#define Buffer struct BUFFER

bool initBuffer(Buffer *b);
bool copyBuffer(Buffer *dst, Buffer *src);
bool fillBuffer(Buffer *b, char c);
bool bufferFromString(Buffer *b, char *str);
bool appendBuffer(Buffer *b, char c);


#endif
