/**********************************************************************
* 2012 Benya, Germany.
*
* FileName:        main.c
* Dependencies:    Header (.h) files if applicable, see below 
* Processor:       PIC24FJ128GA010
* Compiler:        MPLAB C30 v3.11 or higher
*
*
* REVISION HISTORY:
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* Author            Date      		Comments on this revision
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
* Domnic Savio	   10/07/12			First Release
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
*
* ADDITIONAL NOTES:
* Code Tested on:
* Explorer 16 Demo board with  PIC24FJ128GA010 controller and Windows Hyperterminal program
* 
* DESCRIPTION:
* 
*************************************************************************************************************************/


#include <p24fj128ga010.h>
#include <stdio.h>
#include "main.h"


//#define FCY 16000000LL              // Define clock speed (16MIPS, LL = 64 bit long)

//_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_ON & ICS_PGx2 & FWDTEN_OFF)
//_CONFIG2(IESO_OFF & FCKSM_CSDCMD & OSCIOFNC_OFF &  FNOSC_FRC & POSCMOD_HS)


_CONFIG1(JTAGEN_OFF & GCP_OFF & GWRP_OFF & BKBUG_ON & ICS_PGx2 & FWDTEN_ON)
_CONFIG2(IESO_OFF & FCKSM_CSDCMD & OSCIOFNC_ON &  FNOSC_PRIPLL & POSCMOD_HS)


// Configuration using internal RC Oscillator

// JTAG/Code Protect/Write Protect/Clip-on Emulation mode/
// Watchdog Timer/ICD pins select
//_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF & COE_OFF & FWDTEN_OFF & ICS_PGx2) 

// Disable CLK switch & Fail safe Clk Monitor, OSCO or Fosc/2, 
// Primary Oscillator Mode: Disabled, Internal Fast RC oscillator with 4xPLL
//_CONFIG2( FCKSM_CSDCMD & OSCIOFNC_ON & POSCMOD_NONE & FNOSC_FRC)
 

main()
{  
    initLCD(); // initializations
    putstringLCD("Init Rs");    
    initUARTs();  // 1. init the UART 1 & UART2 serial port  
    init_RI_timer();
    configInputCapture2();
	gps_state = GPS_INITIAL;
	gprs_state = GPRS_INITIAL;
	init_UART_timer();   
	init_GPS_timer(); 
	clrLCD();
	putstringLCD("Tracker ");
	putstringLCD("Started");
	while (1)
	{   
        int i;
        for (i=0;i<0xFFFF;i++); // add delay 
        DELAY();
   		DELAY();
	} // main loop 
}// main



