#include "tt_gps.h"
#include "tt_timer.h"
#include "tt_lcd.h"  
#include "tt_uart.h"  
#include "buffer.h"
#include "tt_atframes.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// AT Commands to get GPS GLL Info
char oky[]           =("\n\rOK\n\r");
char errr[]         =("Blah Blub\n");
char *ok = "\n\rOK\n\r";

// GPS Response Messages
char loc_unknown[]    =("\n\r+CGPSSTATUS: Location Unknown\r\n");
char loc_not_fixed[]  =("\n\r+CGPSSTATUS: Location Not Fix\r\n");
char loc_2D_fix[]     =("\n\r+CGPSSTATUS: Location 2D Fix\r\n");
char loc_3D_fix[]     =("\n\r+CGPSSTATUS: Location 3D Fix\r\n");

unsigned int gps_state;
Buffer b;
  
  
void process_GPS_DATA(char *u2s)
{ 
	//// TODO - do  a comparision on own 
	/*
	if (strstr(rx_buf, oky)==0)
	{		
		 process_GPS_states();
	}else
	{		 
		increment_gps_timer_count();
		start_GPS_timer();
	}
	*/
}

 
void process_GPS_states()
{
	switch(gps_state)
        {
	        // Turn ON GPS
	        case GPS_INITIAL:	  
	        	gps_state = GPS_TURN_ON;
	        	init_gps_timer_count();  
	        	mk_GPS_ON(&b);     
	        	putstring_U2(&b);  
	       	break;
	       	case GPS_TURN_ON:
	       		gps_state = GPS_RESET;
	       		mk_GPS_RESET(&b);     
	        	putstring_U2(&b);	 
	       		init_gps_timer_count();       		
	        	//clrLCD();  
   				//putstringLCD("RESET GPS\n");
   			break;
	       	// Turn OFF GPS
	       	case GPS_STATUS:
	       		gps_state = GPS_INF4;	        	
	        	mk_GPS_INF_GLL(&b);    
	        	putstring_U2(&b); 
	       	break;
	       	
	       	// RESET GPS
	       	case GPS_RESET:
	        	// Start timer and wait for 50 Seconds
	        	gps_state = GPS_RUNNING; 
	        	//putstringLCD("Waiting .... ");
	        	start_GPS_timer();	        
	       	break;
	       	
	       	case GPS_INF4:
	        	// Get GPS Info
	        	gps_state = GPS_SLEEP;
	        //	putstringLCD("GPS Info RX\n");	        	
	        	mk_GPS_OFF(&b);     
	        	putstring_U2(&b);	        
	       	break;
	       	
	       	case GPS_RUNNING:
	        // Check if the timer is still running
	        	gps_state = GPS_STATUS;
	        	mk_GPS_STATUS(&b);     
	        	putstring_U2(&b);
	        // If time out happened then exit loop	        
	       	break;
	       	
	       	case GPS_TIMEOUT:
	        	// No Sattelite in view, turn OFF GPS Module
	        	gps_state = GPS_SLEEP;
	        //	putstringLCD("No Sattelite in view\n");
	        	mk_GPS_OFF(&b);     
	        	putstring_U2(&b);          	      
	       	break;
	       	
	       	case GPS_SLEEP:
	       		// Tag alert received - turn ON GPS	
	       		gps_state = GPS_TURN_ON;
	       	//	clrLCD();  
   			//	putstringLCD("Tag RX Triggered");	
   				mk_GPS_ON(&b);     
	        	putstring_U2(&b);
	       	break; 
	       	default:
	       	//	putstringLCD("Unknown State");
	       	break; 
        }// Switch - case       
}// process_GPS_States

