/** \file
 */

/*
 *  
 * Title:   AT Frames for GPS and GPSRS
 * Author(s): Domnic Savio
 *
 * ------------------------------------------------------------------
 * @version: $Id: atframes.c,v 1.5.2.3 2012/07/14 18:12:40 benya Exp $
 * ------------------------------------------------------------------ 
 *
 */
 
 #include "tt_atframes.h"
 #include "util.h"
 
 void mk_SMS_LIST(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'C';
  buf->data[4] = 'M';
  buf->data[5] = 'G'; 
  buf->data[6] = 'L';  
  buf->data[7] = '=';
  buf->data[8] = '"';
  buf->data[9] = 'R';
  buf->data[10] = 'E';  
  buf->data[11] = 'C';
  buf->data[12] = ' ';
  buf->data[13] = 'U';  
  buf->data[14] = 'N';
  buf->data[15] = 'R';
  buf->data[16] = 'E';
  buf->data[17] = 'A';
  buf->data[18] = 'D';
  buf->data[19] = '"';
  buf->data[20] = ',';
  buf->data[21] = '0';
  buf->data[22] = CR;
  buf->len = 23;
} 

void mk_SMS_READ(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'C';
  buf->data[4] = 'M';
  buf->data[5] = 'G'; 
  buf->data[6] = 'R';  
  buf->data[7] = '=';
  buf->data[8] = 'A';
  buf->data[9] = 'R';
  buf->data[10] = 'A';  
  buf->data[11] = '=';
  buf->data[12] = '0';
  buf->data[13] = ',';  
  buf->data[14] = '1';
  buf->data[15] = CR; 
  buf->len = 16;
} 
 
void mk_GPS_ON(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'C';
  buf->data[4] = 'G';
  buf->data[5] = 'P'; 
  buf->data[6] = 'S';  
  buf->data[7] = 'P';
  buf->data[8] = 'W';
  buf->data[9] = 'R';
  buf->data[10] = '=';
  buf->data[11] = '1';
  buf->data[12] = CR; 
  buf->len = 13;
}

void mk_GPS_OFF(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'C';
  buf->data[4] = 'G';
  buf->data[5] = 'P'; 
  buf->data[6] = 'S';  
  buf->data[7] = 'P';
  buf->data[8] = 'W';
  buf->data[9] = 'R';
  buf->data[10] = '=';
  buf->data[11] = '0';
  buf->data[12] = CR; 
  buf->len = 13;
}

void mk_GPS_INF_GLL(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'C';
  buf->data[4] = 'G';
  buf->data[5] = 'P'; 
  buf->data[6] = 'S';  
  buf->data[7] = 'I';
  buf->data[8] = 'N';
  buf->data[9] = 'F';
  buf->data[10] = '=';
  buf->data[11] = '4';
  buf->data[12] = CR; 
  buf->len = 13;
}

void mk_GPS_RESET(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'C';
  buf->data[4] = 'G';
  buf->data[5] = 'P'; 
  buf->data[6] = 'S';  
  buf->data[7] = 'R';
  buf->data[8] = 'S';
  buf->data[9] = 'T';
  buf->data[10] = '=';
  buf->data[11] = '0';
  buf->data[12] = CR; 
  buf->len = 13;
}

void mk_GPS_STATUS(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'C';
  buf->data[4] = 'G';
  buf->data[5] = 'P'; 
  buf->data[6] = 'S';  
  buf->data[7] = 'S';
  buf->data[8] = 'T';
  buf->data[9] = 'A';
  buf->data[10] = 'T';
  buf->data[11] = 'U';
  buf->data[12] = 'S';
  buf->data[13] = '=';
  buf->data[14] = '?';
  buf->data[15] = CR; 
  buf->len = 16;
}

void mk_GPS_INF(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'C';
  buf->data[4] = 'G';
  buf->data[5] = 'P'; 
  buf->data[6] = 'S';  
  buf->data[7] = 'I';
  buf->data[8] = 'N';
  buf->data[9] = 'F';
  buf->data[10] = '?';
  buf->data[11] = CR;  
  buf->len = 12;
}

void mk_GPS_SYNC(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'A';
  buf->data[2] = 'A';
  buf->data[3] = 'A';
  buf->data[4] = 'A';
  buf->data[5] = 'A'; 
  buf->data[6] = 'A';  
  buf->data[7] = 'A';
  buf->data[8] = 'A';
  buf->data[9] = 'A';
  buf->data[10] = 'A';
  buf->data[11] = CR;  
  buf->len = 12;
} 
 

void mk_GPRS_CPIN(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'C';
  buf->data[4] = 'P';
  buf->data[5] = 'I'; 
  buf->data[6] = 'N';
  buf->data[7] = '?';
  buf->data[8] = CR;  
  buf->len = 9;
}

void mk_GPRS_CREG(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'C';
  buf->data[4] = 'R';
  buf->data[5] = 'E'; 
  buf->data[6] = 'G';
  buf->data[7] = '?';
  buf->data[8] = CR;  
  buf->len = 9;
}

void mk_GPRS_CSQ(Buffer *buf) 
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'C';
  buf->data[4] = 'S';
  buf->data[5] = 'Q';  
  buf->data[6] = CR;  
  buf->len = 7;
} 
void mk_GPRS_CGATT(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'C';
  buf->data[4] = 'G';
  buf->data[5] = 'A'; 
  buf->data[6] = 'T';  
  buf->data[7] = 'T';
  buf->data[8] = '=';
  buf->data[9] = '1'; 
  buf->data[10] = CR;  
  buf->len = 11;
}

// AT+SAPBR=1,1
void mk_GPRS_SAPBR_1(Buffer *buf) 
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'S';
  buf->data[4] = 'A';
  buf->data[5] = 'P'; 
  buf->data[6] = 'B';  
  buf->data[7] = 'R';
  buf->data[8] = '=';
  buf->data[9] = '1';
  buf->data[10] = ',';
  buf->data[11] = '1';  
  buf->data[12] = CR;
  buf->len = 13;
}

// AT+SAPBR=2,1 - GET THE IP ADDRESS
void mk_GPRS_SAPBR_2(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'S';
  buf->data[4] = 'A';
  buf->data[5] = 'P'; 
  buf->data[6] = 'B';  
  buf->data[7] = 'R';
  buf->data[8] = '=';
  buf->data[9] = '2';
  buf->data[10] = ',';
  buf->data[11] = '1';  
  buf->data[12] = CR;
  buf->len = 13;
} 

// AT+SAPBR=3,1,"Contype","GPRS"
void mk_GPRS_SAPBR_3(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'S';
  buf->data[4] = 'A';
  buf->data[5] = 'P'; 
  buf->data[6] = 'B';  
  buf->data[7] = 'R';
  buf->data[8] = '=';
  buf->data[9] = '3';
  buf->data[10] = ',';
  buf->data[11] = '1';   
  buf->data[12] = ',';
  buf->data[13] = '"';
  buf->data[14] = 'C';
  buf->data[15] = 'o';
  buf->data[16] = 'n';
  buf->data[17] = 't';
  buf->data[18] = 'y'; 
  buf->data[19] = 'p';  
  buf->data[20] = 'e';
  buf->data[21] = '"';
  buf->data[22] = ',';
  buf->data[23] = '"';
  buf->data[24] = 'G';
  buf->data[25] = 'P';   
  buf->data[26] = 'R'; 
  buf->data[27] = 'S'; 
  buf->data[28] = '"'; 
  buf->data[29] = CR;
  buf->len = 30;
}

// TODO
void mk_GPRS_SAPBR_3_APN(Buffer *buf){} 
void mk_GPRS_SAPBR_3_USER(Buffer *buf){}
void mk_GPRS_SAPBR_3_PWD(Buffer *buf){}


// AT+HTTPINIT 
void mk_GPRS_HTTP_INIT(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'H';
  buf->data[4] = 'T';
  buf->data[5] = 'T'; 
  buf->data[6] = 'P';  
  buf->data[7] = 'I';
  buf->data[8] = 'N';
  buf->data[9] = 'I';
  buf->data[10] = 'T';   
  buf->data[11] = CR;
  buf->len = 12;
} 

//AT+HTTPPARA="CID",1 //Set parameters for HTTP session
void mk_GPRS_HTTP_CID(Buffer *buf) 
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'H';
  buf->data[4] = 'T';
  buf->data[5] = 'T'; 
  buf->data[6] = 'P';  
  buf->data[7] = 'P';
  buf->data[8] = 'A';
  buf->data[9] = 'R';
  buf->data[10] = 'A';  
  buf->data[11] = '=';
  buf->data[12] = '"';
  buf->data[13] = 'C';  
  buf->data[14] = 'I';
  buf->data[15] = 'D';
  buf->data[16] = '"';
  buf->data[17] = ',';
  buf->data[18] = '1';   
  buf->data[19] = CR;
  buf->len = 20;
}

// AT+HTTPPARA="URL","***" 
/*
This function would make the frame until the comma
after the URL. The rest of the strings "***"CR has
to be built during run time after the configuration
has taken place from an SMS.
*/
void mk_GPRS_HTTP_PARA(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'H';
  buf->data[4] = 'T';
  buf->data[5] = 'T'; 
  buf->data[6] = 'P';  
  buf->data[7] = 'P';
  buf->data[8] = 'A';
  buf->data[9] = 'R';
  buf->data[10] = 'A';  
  buf->data[11] = '=';
  buf->data[12] = '"';
  buf->data[13] = 'U';  
  buf->data[14] = 'R';
  buf->data[15] = 'L';
  buf->data[16] = '"';
  buf->data[17] = ',';
  buf->len = 18;
}   

// AT+HTTPDATA="deviceid","***" 
/*
This function would make the frame until the =
sign. The rest of the strings e.g. deviceid and
the value  "***"CR has to be built during run 
time after the configuration and tag info is
available.
*/
void mk_GPRS_HTTP_DATA(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'H';
  buf->data[4] = 'T';
  buf->data[5] = 'T'; 
  buf->data[6] = 'P';  
  buf->data[7] = 'D';
  buf->data[8] = 'A';
  buf->data[9] = 'T';
  buf->data[10] = 'A';  
  buf->data[11] = '='; 
  buf->len = 12;
}

// AT+HTTPACTION=1   //Start HTTP post session.
void mk_GPRS_HTTP_ACTION(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'H';
  buf->data[4] = 'T';
  buf->data[5] = 'T'; 
  buf->data[6] = 'P';  
  buf->data[7] = 'A';
  buf->data[8] = 'C';
  buf->data[9] = 'T';
  buf->data[10] = 'I';  
  buf->data[11] = 'O'; 
  buf->data[12] = 'N';
  buf->data[13] = '=';  
  buf->data[14] = '1';  
  buf->data[15] = CR;
  buf->len = 16;
}

//AT+HTTPTERM //Terminate HTTP service
void mk_GPRS_HTTP_TERM(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'H';
  buf->data[4] = 'T';
  buf->data[5] = 'T'; 
  buf->data[6] = 'P';  
  buf->data[7] = 'T';
  buf->data[8] = 'E';
  buf->data[9] = 'R';
  buf->data[10] = 'M';  
  buf->data[11] = CR;
  buf->len = 12;
}


// TODO
void mk_GPRS_INIT(Buffer *buf){}
void mk_GPRS_SLEEP(Buffer *buf){}


void mk_GPRS_CPIN_RESP(Buffer *buf)
{	 
	 buf->data[0] = 0x0A;
	 buf->data[1] = 0x2B;
	 buf->data[2] = 0x43;
	 buf->data[3] = 0x50;
	 buf->data[4] = 0x49;
	 buf->data[5] = 0x4E;
	 buf->data[6] = 0x3A;
	 buf->data[7] = 0x20;
	 buf->data[8] = 0x52;
	 buf->data[9] = 0x45;
	 buf->data[10] = 0x41;
	 buf->data[11] = 0x44;
	 buf->data[12] = 0x59;
	 buf->data[13] = 0x0D;
	 buf->data[14] = 0x0A;  
  	 buf->len = 15;
}

void mk_GPRS_CREG_RESP(Buffer *buf)
{
	buf->data[0] = 0x0A;
	buf->data[1] = 0x2B;
	buf->data[2] = 0x43;
	buf->data[3] = 0x52;
	buf->data[4] = 0x45;
	buf->data[5] = 0x47;
	buf->data[6] = 0x3A;
	buf->data[7] = 0x20;
	buf->data[8] = 0x32;
	buf->data[9] = 0x2C;
	buf->data[10] = 0x31;
	buf->data[11] = 0x2C;
	buf->data[12] = 0x22;  
    buf->len = 13;
}

void mk_GPRS_CSQ_RESP(Buffer *buf) 
{
	buf->data[0] =  0x0A;
	buf->data[1] =  0x2B;
	buf->data[2] = 0x43;
	buf->data[3] = 0x53;
	buf->data[4] = 0x51;
	buf->data[5] = 0x3A;
	buf->data[6] = 0x20;
	buf->data[7] = 0x31;
	buf->data[8] = 0x33;
	buf->data[9] = 0x2C;
	buf->data[10] = 0x30;
	buf->data[11] = 0x0D;
	buf->data[12] = 0x0A;  
  	buf->len = 13;
} 

/* Response for all these commands
 CGATT,  AT+SAPBR=3,1
 AT+HTTPINIT, AT+HTTPCID, AT+HTTPURL,
 AT+HTTPDATA, AT+HTTPACTION,  
 HTTP_TERM
 */
void mk_GPRS_OK_RESP(Buffer *buf)
{
  buf->data[0] = 0x0A;
  buf->data[1] = 0x4F;
  buf->data[2] = 0x4B;
  buf->data[3] = 0x0D;
  buf->data[4] = 0x0A;
  buf->len = 5;
}

// AT+SAPBR=2,1 - GET THE IP ADDRESS
void mk_GPRS_SAPBR_2_RESP(Buffer *buf)
{
  buf->data[0] = 0x0A;
  buf->data[1] = 0x2B;
  buf->data[2] = 0x53;
  buf->data[3] = 0x41;
  buf->data[4] = 0x50;
  buf->data[5] = 0x42;
  buf->data[6] = 0x52;
  buf->data[7] = 0x3A;
  buf->data[8] = 0x20;
  buf->data[9] = 0x31;
  buf->data[10] = 0x2C;
  buf->data[11] = 0x31;
  buf->data[12] = 0x2C;
  buf->data[13] = 0x22; 
  buf->len = 14;
} 

// TODO
void mk_GPRS_SAPBR_3_APN_RESP(Buffer *buf){} 
void mk_GPRS_SAPBR_3_USER_RESP(Buffer *buf){}
void mk_GPRS_SAPBR_3_PWD_RESP(Buffer *buf){}


//AT+HTTPPARA="CID",1 //Set parameters for HTTP session
void mk_GPRS_HTTP_CID_RESP(Buffer *buf) 
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'H';
  buf->data[4] = 'T';
  buf->data[5] = 'T'; 
  buf->data[6] = 'P';  
  buf->data[7] = 'P';
  buf->data[8] = 'A';
  buf->data[9] = 'R';
  buf->data[10] = 'A';  
  buf->data[11] = '=';
  buf->data[12] = '"';
  buf->data[13] = 'C';  
  buf->data[14] = 'I';
  buf->data[15] = 'D';
  buf->data[16] = '"';
  buf->data[17] = ',';
  buf->data[18] = '1';   
  buf->data[19] = CR;
  buf->len = 20;
}

// AT+HTTPPARA="URL","***" 
/*
This function would make the frame until the comma
after the URL. The rest of the strings "***"CR has
to be built during run time after the configuration
has taken place from an SMS.
*/
void mk_GPRS_HTTP_PARA_RESP(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'H';
  buf->data[4] = 'T';
  buf->data[5] = 'T'; 
  buf->data[6] = 'P';  
  buf->data[7] = 'P';
  buf->data[8] = 'A';
  buf->data[9] = 'R';
  buf->data[10] = 'A';  
  buf->data[11] = '=';
  buf->data[12] = '"';
  buf->data[13] = 'U';  
  buf->data[14] = 'R';
  buf->data[15] = 'L';
  buf->data[16] = '"';
  buf->data[17] = ',';
  buf->len = 18;
}   

// AT+HTTPDATA="deviceid","***" 
/*
This function would make the frame until the =
sign. The rest of the strings e.g. deviceid and
the value  "***"CR has to be built during run 
time after the configuration and tag info is
available.
*/
void mk_GPRS_HTTP_DATA_RESP(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'H';
  buf->data[4] = 'T';
  buf->data[5] = 'T'; 
  buf->data[6] = 'P';  
  buf->data[7] = 'D';
  buf->data[8] = 'A';
  buf->data[9] = 'T';
  buf->data[10] = 'A';  
  buf->data[11] = '='; 
  buf->len = 12;
}

// AT+HTTPACTION=1   //Start HTTP post session.
void mk_GPRS_HTTP_ACTION_RESP(Buffer *buf)
{
  buf->data[0] = 'A';
  buf->data[1] = 'T';
  buf->data[2] = '+';
  buf->data[3] = 'H';
  buf->data[4] = 'T';
  buf->data[5] = 'T'; 
  buf->data[6] = 'P';  
  buf->data[7] = 'A';
  buf->data[8] = 'C';
  buf->data[9] = 'T';
  buf->data[10] = 'I';  
  buf->data[11] = 'O'; 
  buf->data[12] = 'N';
  buf->data[13] = '=';  
  buf->data[14] = '1';  
  buf->data[15] = CR;
  buf->len = 16;
}
