
/** \file
 */

/*
 *  
 * Title:   AT Frames for GPS and GPSRS
 * Author(s): Domnic Savio
 *
 * ------------------------------------------------------------------
 * @version: $Id: tt_atframes.h,v 1.5.2.3 2012/07/14 18:12:40 benya Exp $
 * ------------------------------------------------------------------ 
 *
 */
 
#include "buffer.h"

void mk_SMS_LIST(Buffer *buf);
void mk_SMS_READ(Buffer *buf);

void mk_GPS_ON(Buffer *buf);
void mk_GPS_OFF(Buffer *buf);
void mk_GPS_INF(Buffer *buf);
void mk_GPS_INF_GLL(Buffer *buf);
void mk_GPS_SYNC(Buffer *buf);
void mk_GPS_RESET(Buffer *buf);
void mk_GPS_STATUS(Buffer *buf); 

// GPRS - INITIALIZATION
void mk_GPRS_CPIN(Buffer *buf); 
void mk_GPRS_CREG(Buffer *buf);
void mk_GPRS_CSQ(Buffer *buf); 
void mk_GPRS_CGATT(Buffer *buf);
void mk_GPRS_SAPBR_1(Buffer *buf); 
void mk_GPRS_SAPBR_2(Buffer *buf); 
void mk_GPRS_SAPBR_3(Buffer *buf); 
void mk_GPRS_HTTP_TERM(Buffer *buf); 

// GPRS HTTP POST RELATED
void mk_GPRS_HTTP_INIT(Buffer *buf); 
void mk_GPRS_HTTP_CID(Buffer *buf);  
void mk_GPRS_HTTP_PARA(Buffer *buf); 
void mk_GPRS_HTTP_DATA(Buffer *buf); 
void mk_GPRS_HTTP_ACTION(Buffer *buf);


// TODO 
void mk_GPRS_SAPBR_3_APN(Buffer *buf); 
void mk_GPRS_SAPBR_3_USER(Buffer *buf);
void mk_GPRS_SAPBR_3_PWD(Buffer *buf);

//  TODO
void mk_GPRS_INIT(Buffer *buf); 
void mk_GPRS_SLEEP(Buffer *buf);


// GPRS - INITIALIZATION - RESPONSE
void mk_GPRS_OK_RESP(Buffer *buf);
void mk_GPRS_CPIN_RESP(Buffer *buf); 
void mk_GPRS_CREG_RESP(Buffer *buf);
void mk_GPRS_CSQ_RESP(Buffer *buf); 
void mk_GPRS_CGATT_RESP(Buffer *buf);
void mk_GPRS_SAPBR_1_RESP(Buffer *buf); 
void mk_GPRS_SAPBR_2_RESP(Buffer *buf); 
void mk_GPRS_SAPBR_3_RESP(Buffer *buf); 
void mk_GPRS_HTTP_TERM_RESP(Buffer *buf); 

// GPRS HTTP POST RELATED - RESPONSE
void mk_GPRS_HTTP_INIT_RESP(Buffer *buf); 
void mk_GPRS_HTTP_CID_RESP(Buffer *buf);  
void mk_GPRS_HTTP_PARA_RESP(Buffer *buf); 
void mk_GPRS_HTTP_DATA_RESP(Buffer *buf); 
void mk_GPRS_HTTP_ACTION_RESP(Buffer *buf);


// TODO  - RESPONSE
void mk_GPRS_SAPBR_3_APN_RESP(Buffer *buf); 
void mk_GPRS_SAPBR_3_USER_RESP(Buffer *buf);
void mk_GPRS_SAPBR_3_PWD_RESP(Buffer *buf);
