#include "tt_gprs.h" 
#include "tt_timer.h"
#include "tt_lcd.h"  
#include "tt_uart.h"  
#include "buffer.h"
#include "util.h"
#include "tt_atframes.h"
#include "tt_sms.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

// States for the main program logic
unsigned int main_mode;
unsigned int gprs_state;
unsigned int sms_state; 
unsigned int param_data_count;
unsigned int for_loop_count;
Buffer u2b;

// Test POST Messages
char AWS_TEST_SERVER[] = {"http://tracker.elasticbeanstalk.com/tagdata?deviceid=PIC1&devicename=PIC24FDevice%203&lat=49.12311&lng=8.219998&tagid=457845&rxdate=26.07.2012"};
char deviceidlabel[]   = {"deviceid"};
char deviceidvalue[]   = {"EMTest"};
char devicenamelabel[] = {"devicename"};
char devicenamevalue[] = {"PIC24"};
char latlabel[]        = {"lat"};
char latvalue[]        = {"11.111111"};
char lngname[]         = {"lng"};
char lngvalue[]        = {"21.111111"};
char rxdatelabel[]     = {"rxdate"};
char rxdatevalue[]     = {"24.07.1676"};

void init_sms_timer_count()
{
	 
}
void increment_sms_timer_count()
{

}
void process_SMS_DATA(char *u2s)
{
	 process_SMS_states();
}

void process_SMS_states()
{   
	switch(sms_state)
       {
        // Get SMS List
        case SMS_INITIAL:	  
        	sms_state = SMS_LIST_REQ;   
        	initBuffer(&u2b);
        	mk_SMS_LIST(&u2b);     
        	putstring_U2(&u2b);  
       	break;
       	case SMS_LIST_REQ:
       		clrLCD();
       		putstringLCD("SMS LIST");	       		  
        	sms_state = SMS_READ_REQ;  
        	initBuffer(&u2b);   
        	mk_SMS_READ(&u2b);     
        	putstring_U2(&u2b);
       	break;
       	case SMS_READ_REQ:	
       		clrLCD();
       		putstringLCD("SMS READ");       		  
        	sms_state = SMS_SLEEP;  
        	initBuffer(&u2b); 
        	main_mode = MODE_GPS;
        	// Parse the sms message here
       	break;
       	}
  }
  
  
// Function prototypes
void init_gprs_timer_count()
{
	param_data_count = 0;
}
void increment_gprs_timer_count()
{

}
void process_GPRS_DATA(char *u2s)
{
	 process_GPRS_states();
	/*
	if (strstr(rx_buf, CPIN_READY)==0)
	{		
		 process_GPRS_states();
	}else
	{		 
		increment_gprs_timer_count();
		start_GPRS_timer();
	}
	*/

}
void process_GPRS_states()
{   
	switch(gprs_state)
       {
        // Turn ON GPS
        case GPRS_INITIAL:	  
        	gprs_state = CPIN_REQ;   
        	initBuffer(&u2b);
        	mk_GPRS_CPIN(&u2b);     
        	putstring_U2(&u2b);  
       	break;
       	case CPIN_REQ:
       		clrLCD();
       		putstringLCD("CPIN OK");	       		  
        	gprs_state = CREG_REQ;  
        	initBuffer(&u2b);   
        	mk_GPRS_CREG(&u2b);     
        	putstring_U2(&u2b);
       	break;
       	case CREG_REQ:	       		  
        	gprs_state = CSQ_REQ;  
        	initBuffer(&u2b);   
        	mk_GPRS_CSQ(&u2b);     
        	putstring_U2(&u2b);
       	break;
       	case CSQ_REQ:	       		  
        	gprs_state = CGATT_REQ;  
        	initBuffer(&u2b);   
        	mk_GPRS_CGATT(&u2b);     
        	putstring_U2(&u2b);
       	break;
       	case CGATT_REQ:	       		  
        	gprs_state = SAPBR_3_REQ;  
        	initBuffer(&u2b); 
        	mk_GPRS_SAPBR_3(&u2b);     
        	putstring_U2(&u2b);
       	break;
       	case SAPBR_3_REQ:	       		  
        	gprs_state = SAPBR_1_REQ;   
        	initBuffer(&u2b);
        	mk_GPRS_SAPBR_1(&u2b);     
        	putstring_U2(&u2b);
       	break;
       	case SAPBR_1_REQ:	       		  
        	gprs_state = SAPBR_2_REQ;  
        	initBuffer(&u2b); 
        	mk_GPRS_SAPBR_2(&u2b);     
        	putstring_U2(&u2b);
       	break;
       	case SAPBR_2_REQ:	       		  
        	gprs_state = HTTP_INIT_REQ;   
        	initBuffer(&u2b);
        	mk_GPRS_HTTP_INIT(&u2b);     
        	putstring_U2(&u2b);
       	break;
       	
       	case HTTP_INIT_REQ:	       		  
        	gprs_state = HTTP_PARA_REQ_1;   
        	initBuffer(&u2b);
        	mk_GPRS_HTTP_CID(&u2b);     
        	putstring_U2(&u2b);
       	break;
       	
       	case HTTP_PARA_REQ_1:	       		  
        	gprs_state = HTTP_PARA_REQ_2;   
        	initBuffer(&u2b);
        	//AT+HTTPPARA="URL","***"
        	mk_GPRS_HTTP_PARA(&u2b); 
      	 		appendBuffer(&u2b, STORK_FEET);
        	 for(for_loop_count = 0; for_loop_count < sizeof(AWS_TEST_SERVER); for_loop_count++)
	       	 {
		       	 if(appendBuffer(&u2b, AWS_TEST_SERVER[for_loop_count]))
			     {
				     continue;
		       	 }else
		       	 {
			       	 // Memory error
			       	 for_loop_count = 0;
			       	 break;
		       	 }
        	 }
       	    appendBuffer(&u2b, STORK_FEET);
       	    appendBuffer(&u2b, CR); 
        	putstring_U2(&u2b);
       	break;	       	
       	case HTTP_PARA_REQ_2:	 
       	case HTTP_DATA_REQ:       	    
 			initBuffer(&u2b);		  
        	gprs_state = HTTP_DATA_REQ;
        	param_data_count = 6; 
        	mk_GPRS_HTTP_DATA(&u2b);
        	switch(param_data_count)
        	{
	        	case PARAM_DEVICE_ID: 	
	        		 append_at_frame(&u2b, deviceidlabel, sizeof(deviceidlabel), deviceidvalue, sizeof(deviceidvalue));		        	 
		        	 putstring_U2(&u2b);
	        	break;
	        	case PARAM_DEVICE_NAME:
		        	 append_at_frame(&u2b, devicenamelabel, sizeof(devicenamelabel), devicenamevalue, sizeof(devicenamevalue));
		        	 putstring_U2(&u2b);
	        	break;
	        	case PARAM_LAT:
		        	 append_at_frame(&u2b, latlabel, sizeof(latlabel), latvalue, sizeof(latvalue));
		        	 putstring_U2(&u2b);
	        	break;
	        	case PARAM_LNG:
	        		 append_at_frame(&u2b, lngname, sizeof(lngname), lngvalue, sizeof(lngvalue));
	        		 putstring_U2(&u2b);
	        	break;
	        	case PARAM_RXDATE:
	        		 append_at_frame(&u2b, rxdatelabel, sizeof(rxdatelabel), rxdatevalue, sizeof(rxdatevalue));
	        		 putstring_U2(&u2b);
	        	break;
	        	case MAX_DATA_PARAM: 
	        		 param_data_count = 1;
	        		 gprs_state = HTTP_ACT_REQ;
	        		 initBuffer(&u2b);
		        	 mk_GPRS_HTTP_ACTION(&u2b);
		        	 putstring_U2(&u2b);
	        	break;
        	
        	} 
       	break;	       	
       	case HTTP_ACT_REQ:	
       		gprs_state = GPRS_SLEEP;   
        	initBuffer(&u2b);
        	mk_GPRS_HTTP_TERM(&u2b);     
        	putstring_U2(&u2b);       		  
        	gprs_state = MODE_SLEEP;   
        	initBuffer(&u2b); 
       	break;
       	default:
        	gprs_state = GPRS_INITIAL;   
        	initBuffer(&u2b);
        	mk_GPRS_HTTP_TERM(&u2b);     
        	putstring_U2(&u2b);
       	break;
    }	
}

void append_at_frame(Buffer *u2b, char * mlabel, int len1, char * mvalue, int len2)
{ 
	char ch; 
	appendBuffer(u2b, STORK_FEET); 
       	 for(for_loop_count = 0; for_loop_count < len1; for_loop_count++)
       	 {
	       	 ch = mlabel[for_loop_count];
	       	 appendBuffer(u2b, ch);
       	 }
       	 if (u2b->len < MAX_BUF_LEN)
			{
			  appendBuffer(u2b, STORK_FEET); 
			  appendBuffer(u2b, COMMA);
			  appendBuffer(u2b, STORK_FEET);
			}
       	 for(for_loop_count = 0; for_loop_count < len2; for_loop_count++)
       	 {
	       	 ch = mvalue[for_loop_count]; 
	       	 appendBuffer(u2b, ch);
       	 }
    	 appendBuffer(u2b, STORK_FEET); 
		 appendBuffer(u2b, CR); 
}

void post_tag_info()
{
}

void post_device_info()
{

}



