#include "buffer.h"
// states for the main logic
#define MODE_GPS        1
#define MODE_GPRS       2
#define MODE_TAG_READ   3
#define MODE_SLEEP      4
#define MODE_SMS        5

// states for the GPRS operations
#define GPRS_INITIAL    1
#define GPRS_SLEEP      2
#define CSQ_REQ         3
#define CSQ_ERROR       4
#define CREG_REQ        5
#define CREG_ERROR      6
#define CPIN_REQ	    7
#define CPIN_ERROR	    8
#define CGATT_REQ	    9
#define CGATT_ERROR	    10
#define SAPBR_1_REQ	    11
#define SAPBR_1_ERROR   12
#define SAPBR_2_REQ	    13
#define SAPBR_2_ERROR	14
#define SAPBR_3_REQ	    15
#define SAPBR_3_ERROR	16
#define HTTP_INIT_REQ	17
#define HTTP_INIT_ERROR 19
#define HTTP_PARA_REQ_1	20
#define HTTP_PARA_1_ERR 21
#define HTTP_PARA_REQ_2	22
#define HTTP_PARA_2_ERR 23
#define HTTP_DATA_REQ	24
#define HTTP_DATA_ERROR 25
#define HTTP_ACT_REQ  	26
#define HTTP_ACT_ERROR  27


#define PARAM_DEVICE_ID   1
#define PARAM_DEVICE_NAME 2
#define PARAM_LAT         3
#define PARAM_LNG         4
#define PARAM_RXDATE      5
#define MAX_DATA_PARAM    6
#define COMMA             0x2C
#define STORK_FEET        0x22

// States for the main program logic
extern unsigned int main_mode;
extern unsigned int gprs_state;


// Function prototypes
void init_gprs_timer_count();
void increment_gprs_timer_count();
void process_GPRS_DATA(char *u2s);
void process_GPRS_states();
void append_at_frame(Buffer * u2b, char *mlabel, int len1, char *mvalue, int len2);
void post_tag_info();
void post_device_info();

