#include <p24fj128ga010.h>
#include "tt_uart.h" 
#include "tt_timer.h"
#include "tt_lcd.h"
#include "tt_gps.h"
#include "tt_gprs.h"
#include "tt_sms.h"
#include "buffer.h" 
 

char U1_RX_BUF[20]; 
char U2_RX_BUF[180];

void clear_U2_RX_BUF(char *b, int len);
void stopU2Reception();
void turnOnU2Reception();

// initialize the UART2 serial port
void initUARTs( void)
{
	init_U1();
	init_U2();
	//clear_UART_buffers();	
} // initUARTs

void initUARTInterrupts (void)
{
	// Clear the Interrupt status flag
	// Disable the Interrupt
	// Set the Interrupt priority
	// Enable the Interrupt
}// initUARTInterrupts
/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~/
* Author            Date      		Comments on this revision
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~/
* Domnic Savio		06.07.2012		First Release 
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~/
* Routines for the UART 1 - ID-12 is terminated here
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
// Initialize routine for this UART 1
/*void init_U1( void)
{
	U1BRG 	= U1_BRATE;  
	// Clear the Mode register
	U1MODE = 0; 
	// Clear the Status & control register
	U1STA = 0;
	// Enable TX for UART 1
	U1MODEbits.UARTEN = 1;
	// Set low speed Mode
	U1MODEbits.BRGH = 0; 
	// Set the Loop back mode for UART 1 - Testing
	//U1MODEbits.LPBACK = 1;
  	// reset RX flag
 	IFS0bits.U1RXIF = 0;
 	// Transmit Enable Bit
 	// U1STAbits.UTXEN = 1;
 	// Enable Receive Interrupt 
 	IEC0bits.U1RXIE = 1;
 	IEC4bits.U1ERIE = 1;
 	IPC2 = 0x7000; 
	
} // init_U1
*/

void init_U1( void)
{
	//Disable  UART1 Interrupts
	IEC0bits.U1TXIE = 0;
	IEC0bits.U1RXIE = 0;


	U1MODEbits.UARTEN = 1;	//Enable Comm
	U1MODEbits.LPBACK = 0;	//Disable Loopback
	U1MODEbits.ABAUD = 0;	//No Autobaud
	U1MODEbits.IREN = 0;
	U1MODEbits.UEN = 0;
	U1MODEbits.RXINV = 0; // Not sure about this one. Change and check
	U1MODEbits.BRGH = 1;  // High speed mode
	U1MODEbits.PDSEL = 0; //8 Bit No parity
	U1MODEbits.STSEL = 0; // 1 Stop bit
	U1STAbits.UTXINV = 0;
	U1STAbits.UTXBRK = 0; //Transmit Break bit.Change and check
	U1BRG = U1_BRATE;  // 12 Set for 19200 Baud with FY = 4M based on BRGH = 0
	//Enable Transmission
	U1STAbits.UTXEN = 1;  
	// reset RX flag
 	IFS0bits.U1RXIF = 0;
 	// Enable Receive Interrupt 
 	IEC0bits.U1RXIE = 1;
 	IEC4bits.U1ERIE = 1;
 	IPC2 = 0x5000;
} // init_U1


// send a character to the UART2 serial port
int putChar_U1( int c)
{
	//while ( U1_CTS);		        // wait for !CTS, clear to send
	while ( IS_TRANSMIT_BUFFER_FULL_UART1());   // wait while Tx buffer full
	U1TXREG = c;
	return c;
} // putChar_U1

void putstring_U1(Buffer * buf)
{
	char ch;
  	int i = 0;
  	U1STAbits.UTXEN = 1;
  	do
  	{
	  	// transmit until CR or buffer empty
		if(i < buf->len)
	  	{
	    	ch = buf->data[i];
	    	while ( IS_TRANSMIT_BUFFER_FULL_UART1());   // wait while Tx buffer full
			U1TXREG = (unsigned char)ch;
	    	i++;
	  }
	}while(ch != CR);   
} // Put String Uart 1

/*

// wait for a new character to arrive to the UART1 serial port
char getChar_U1( void)
{ 
	U1STAbits.UTXEN = 0;
	while ( !IS_CHAR_READY_UART1() && !is_UART_timeout());	// wait for a new character to arrive 
	IFS0bits.U1RXIF = 0;
	return U1RXREG;		// read the character from the receive buffer
}// getcharUART

void getstring_U1( Buffer *buf )
{
	U1STAbits.UTXEN = 0;
	unsigned int cr_count = 0;
	int i = 0; 
	
    do{
	    // wait for a new character 
        buf->data[i] = getChar_U1();        
        i++;
        if ( buf->data[i]=='\r')
        {cr_count++;}       
         // line feed was twice, end loop     
        if ( cr_count==2)
        {break;}         
    } while ( cr_count==2 ); // until two line feeds are received  
    buf->len = i+1;
} // getstring_U1

*/

// wait for a new character to arrive to the UART1 serial port
char getChar_U1( void)
{ 
	U1STAbits.UTXEN = 0;
	while ( !IS_CHAR_READY_UART1() && !is_UART_timeout());	// wait for a new character to arrive 
	IFS0bits.U1RXIF = 0;
	return U1RXREG;		// read the character from the receive buffer
}// getcharUART

char * getstring_U1( char *u1s, int len)
{
	U1STAbits.UTXEN = 0;
	char *p = u1s;            // copy the buffer pointer 	
	//clear_UART_timeout();
	//start_UART_timer();    
    do{
        *u1s = getChar_U1();       // wait for a new character 
        
        if ( *u1s==0x03)      // end of line, end loop
            break;          
        u1s++;                // increment buffer pointer
        len--;
    } while ( len>1 );      // until buffer full  
    
    // dissable further reception
    // until data is transmitted to backend 
 	IEC0bits.U1RXIE = 0;
 	IEC4bits.U1ERIE = 0;
    
    return p;               // return buffer pointer
} // getstring_U1



/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~/
* Author            Date      		Comments on this revision
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~/
* Domnic Savio		06.07.2012		First Release 
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~/
* Routines for the UART 2 - SIM 908 GPS or GPRS
* PC is terminated here when it is the explorer 16 EVM board
*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/
  
// Initialize routine for this UART 2
void init_U2( void)
{
 	//Disable UART 2 Interrupts initially
 	IEC1bits.U2RXIE = 0;
 	IEC4bits.U2ERIE = 0;
	//Enable Comm
	U2MODEbits.UARTEN = 1;	
	//Disable Loopback
	U2MODEbits.LPBACK = 0;	
	//No Autobaud
	U2MODEbits.ABAUD = 0;	
	U2MODEbits.IREN = 0;
	U2MODEbits.UEN = 0;
	// Not sure about this one. Change and check
	U2MODEbits.RXINV = 0; 
	// Low speed mode
	U2MODEbits.BRGH = 0;
	//8 Bit No parity
	U2MODEbits.PDSEL = 0; 
	// 1 Stop bit
	U2MODEbits.STSEL = 0; 
	U2STAbits.UTXINV = 0;
	//Transmit Break bit. 
	U2STAbits.UTXBRK = 0;
	// 12 Set for 19200 Baud with FY = 4M based on BRGH = 0 
	U2BRG = U2_BRATE;  
	//Disable Transmission
	U2STAbits.UTXEN = 0;  
	// reset RX flag
 	IFS1bits.U2RXIF = 0;  
 	// Priority for U2 RX is 7
 	IPC7 = 0x0500;  
 		//Disable UART 2 Interrupts initially
 	IEC1bits.U2RXIE = 0;
 	IEC4bits.U2ERIE = 0;
	
} // init_U2

// send a character to the UART2 serial port
int putChar_U2( int c)
{
	//Enable Transmission
	U2STAbits.UTXEN = 1;  
	
	// while ( U2_CTS);		        // wait for !CTS, clear to send
	while ( IS_TRANSMIT_BUFFER_FULL_UART2());   // wait while Tx buffer full
	U2TXREG = c;
	// reset RX flag
 	IFS1bits.U2RXIF = 0; 
 	//IEC1bits.U2RXIE = 1;
 	//IEC4bits.U2ERIE = 1;
	return c;
} // putChar_U2

void putstring_U2(Buffer * buf)
{   	
 	char ch;
  	int i = 0;
  	U2STAbits.UTXEN = 1;
  	clear_U2_RX_BUF(U2_RX_BUF, sizeof(U2_RX_BUF));
  	do
  	{
	  	// transmit until CR or buffer empty
		if(i < buf->len)
	  	{
	    	ch = buf->data[i];
	    	// wait while Tx buffer full
	    	while ( IS_TRANSMIT_BUFFER_FULL_UART2());   
			U2TXREG = (unsigned char)ch;
	    	i++;
	  }
	}while(ch != CR);  
	turnOnU2Reception();	   
} // putChar_U2


// wait for a new character to arrive to the UART2 serial port
char getChar_U2( void)
{
	U2STAbits.UTXEN = 0;
    //U2_RTS = 0;            // assert Request To Send !RTS
	while ( !IS_CHAR_READY_UART2());	// wait for a new character to arrive
	//U2_RTS = 1;
	IFS1bits.U2RXIF = 0;
	return U2RXREG;		// read the character from the receive buffer
}// getcharUART

/*
void getstring_U2( Buffer * buf )
{
	U2STAbits.UTXEN = 0;
	unsigned int cr_count = 0;
	int i = 0; 
	
    do{
	    // wait for a new character 
        buf->data[i] = getChar_U2();        
        i++;
        if ( buf->data[i]=='\r')
        {cr_count++;}       
         // line feed was twice, end loop     
        if ( cr_count==2)
        {break;}         
    } while ( cr_count==2 ); // until two line feeds are received  
    buf->len = i+1;
    return;
} // getstring_U2
*/

char * getstring_U2( char *u2s, int len)
{
	U2STAbits.UTXEN = 0;
	unsigned int cr_count = 0;
    char *p = u2s;            // copy the buffer pointer 
    do{
        *u2s = getChar_U2();       // wait for a new character  
        if ( *u2s==0x0A)
        {cr_count++;}            // line feed, end loop 
        if ( cr_count==2)
        {break;}          
        u2s++;                // increment buffer pointer
        len--;
    } while ( len>1 );      // until buffer full  
    return p;               // return buffer pointer       // return buffer pointer
} // getstring_U1

void clear_U2_RX_BUF(char *b, int len)
{
	int i = 0;
	if (b != NULL)
    { 
      for (i=0; i<len; i++)
		{
			b[i] = (char) 0xBB; 
		}
	}
}

void turnOnU2Reception()
{
	// reset RX flag
 	IFS1bits.U2RXIF = 0; 
 	IEC1bits.U2RXIE = 1;
 	IEC4bits.U2ERIE = 1; 
}

void stopU2Reception()
{
	// reset RX flag
 	IFS1bits.U2RXIF = 0; 
 	IEC1bits.U2RXIE = 0;
 	IEC4bits.U2ERIE = 0; 
}


void __attribute__ ((interrupt,no_auto_psv)) _U1RXInterrupt(void) 
 { 
 	// Clear the interrupt flag
     IFS0bits.U1RXIF = 0;  
 	// Check for over run error
     if( U1STAbits.OERR )           // if overrun, clear OERR flag
         U1STAbits.OERR = 0;        // according to datasheet paragraph 16.5
  	// Deal with the data here   
  	getstring_U1(U1_RX_BUF, sizeof(U1_RX_BUF));

 	// Disable U1 Receive Interrupt 
 	IEC0bits.U1RXIE = 0;
 	IEC4bits.U1ERIE = 0;
 	//putstringLCD("U1 Tag RX"); 
 	// main_mode = MODE_GPS;
 	//------ Testing--------//
 	main_mode = MODE_GPRS;
 	clrLCD(); 
 	putstringLCD("Tag Rx");
 	process_GPRS_states();
 	//------ Testing--------// 	
 }


void __attribute__ ((interrupt,no_auto_psv)) _U2RXInterrupt(void) 
 {       
    // disable further RX Interrupt
 	stopU2Reception();
 	// Check for over run error
     if( U2STAbits.OERR )           // if overrun, clear OERR flag
         U2STAbits.OERR = 0;        // according to datasheet paragraph 16.5
	// Deal with the data here  
 	getstring_U2(U2_RX_BUF, sizeof(U2_RX_BUF));
 	
  	if(main_mode == MODE_GPS)
  	{
	  	// Process G P S
  		process_GPS_DATA(U2_RX_BUF);
  	} 
  	else if(main_mode == MODE_GPRS)
  	{
	  	// Process G P R S 
  		process_GPRS_DATA(U2_RX_BUF);
  	} 
  	else if(main_mode == MODE_SMS)
  	{
	  	// Process G P R S 
  		process_SMS_DATA(U2_RX_BUF);
  	}  
  	
 }

void __attribute__ ((interrupt, no_auto_psv)) _U1ErrInterrupt(void)
{
	IFS4bits.U1ERIF = 0; // Clear the UART1 Error Interrupt 
	
 	IEC4bits.U1ERIE = 0;
 	IEC4bits.U1ERIE = 1;
 //	putstringLCD("U1 - Error");
} 

void __attribute__ ((interrupt, no_auto_psv)) _U2ErrInterrupt(void)
{
	IFS4bits.U2ERIF = 0; // Clear the UART2 Error Interrupt Flag
//	putstringLCD("U2 - Error");
}

