
/*
 *  
 * Title:   Utilities
 * Author(s): Domnic Savio
 *
 * ------------------------------------------------------------------
 * @version: $Id: tt_util.h,v 1.5.2.3 2012/07/14 18:12:40 benya Exp $
 * ------------------------------------------------------------------ 
 *
 */

#ifndef UTIL_H
#define UTIL_H

/// Boolean data type with false and true.
typedef enum { false = 0, true = 1 } bool;

/// Switch with ON and OFF.
typedef enum  { OFF = 0, ON = 1 } OnOffSwitch;

#ifndef NULL
/// NULL pointer, if not already defined
#define NULL  ((void *) 0)
#endif
 

#define bitset(var,bitno) ((var) |= 1 << (bitno))
#define bitclr(var,bitno) ((var) &= ~(1 << (bitno)))

#define set(var,val) ((var) |= (val))
#define clr(var,val) ((var) &= ~(val))

// Data related definitions
#define CR                ((char) 0x0D)
#define LFEED             ((char) 0x0A)

#endif
